package moe.jansel.platinum

import org.bukkit.Server
import org.bukkit.command.CommandExecutor
import org.bukkit.command.PluginCommand
import org.bukkit.command.TabCompleter
import org.bukkit.plugin.PluginManager
import org.bukkit.plugin.java.JavaPlugin
import org.bukkit.scheduler.BukkitScheduler
import java.util.logging.Logger

@Suppress("unused")
class Platinum : JavaPlugin() {
    companion object {
        lateinit var instance: Platinum
        lateinit var pluginManager: PluginManager
        lateinit var logger: Logger
        lateinit var server: Server
        lateinit var scheduler: BukkitScheduler
    }
    override fun onEnable() {

    }

    override fun onLoad() {
        logger.info("Loading Platinum")
    }

    override fun onDisable() {
        // Plugin shutdown logic
    }

    private fun registerCommands() {
        "platinum".cmd() execs CommandExecutor { commandSender, command, name, args ->
            true
        }
    }

    private fun String.cmd() = instance.getCommand(this) ?: throw NullPointerException("Command '$name' not found!")
    private infix fun PluginCommand.complete(with: TabCompleter) { this.tabCompleter = with }
    private infix fun PluginCommand.execs(thing: CommandExecutor) = this.also { setExecutor(thing) }
}
